
<!DOCTYPE html>
<html>
<head>
    <style> 
        /* Set the style for the body to remove margin and set the globe container to full viewport width and height */
        body { margin: 0; }
        #globeViz { width: 100vw; height: 100vh; }
    </style>

    <!-- Importing necessary libraries: Three.js for 3D rendering, topojson-client for geographic data processing, and globe.gl for creating the globe visualization -->
    <script src="https://unpkg.com/three"></script>
    <script src="https://unpkg.com/topojson-client@3"></script>
    <script src="https://unpkg.com/globe.gl"></script>
</head>

<body>
    <!-- Container for the globe visualization -->
    <div id="globeViz"></div>

    <script>
        // Initialize the globe visualization in the specified container
        const world = Globe()(document.getElementById('globeViz'))
            .backgroundColor('rgba(255, 255, 255, 1)') // Set the background color of the globe
            .showGlobe(true) // Ensure the globe itself is shown
            .showAtmosphere(false); // Disable the atmosphere layer for a clearer view

        // Fetch geographic data for the landmasses and process it for visualization
        fetch('https://unpkg.com/world-atlas/land-110m.json').then(res => res.json())
            .then(landTopo => {
                world
                    .polygonsData(topojson.feature(landTopo, landTopo.objects.land).features) // Define the landmasses on the globe
                    .polygonCapMaterial(new THREE.MeshLambertMaterial({ color: 'rgba(139, 149, 246, 1)', side: THREE.DoubleSide })) // Set the material for the landmasses
                    .polygonSideColor(() => 'rgba(255, 255, 255, 1)'); // Set the side color of landmass polygons

                // Generate random data for spikes (representing some kind of data points on the globe)
                const N = 300;
                const gData = [...Array(N).keys()].map(() => ({
                    lat: (Math.random() - 0.5) * 180, // Random latitude
                    lng: (Math.random() - 0.5) * 360, // Random longitude
                    size: Math.random() * 0.3 + 0.05, // Random size for the spike
                    radius: Math.random() * 0.9 + 0.1, // Random size for the spike
                    color: ['rgba(255, 127, 42, 1)', 'rgba(255, 127, 42, 1)', 'rgba(255, 67, 42, 1)', 'rgba(160, 160, 42, 0.8)', 'rgba(100, 200, 42, 0.7)', 'rgba(110, 150, 200, 0.5)'][Math.round(Math.random() * 5)] // Random color selection
                }));

                // Add spikes to the globe based on the generated data
                world.pointsData(gData)
			              .pointRadius("radius")
                    .pointAltitude('size') // Use the size property to determine the altitude of each point (spike)
                    .pointColor('color'); // Use the color property to determine the color of each point (spike)

                // Set the material properties for the globe
                const globeMaterial = world.globeMaterial();
                globeMaterial.specular = new THREE.Color('grey'); // Set the specular color of the globe material
                globeMaterial.color.set(0xA2A9F8); // Set the base color of the globe material
                globeMaterial.flatshading = false; // Disable flat shading

                // Add auto-rotation to the globe for a dynamic visualization effect
                world.controls().autoRotate = true; // Enable auto-rotation
                world.controls().autoRotateSpeed = 0.6; // Set the speed of auto-rotation
            });
    </script>
</body>
</html>

